Merge pull request #11699 from swgillespie/local-gc-branch-merge
[platform/upstream/coreclr.git] / init-tools.sh
1 #!/usr/bin/env bash
2
3 __scriptpath=$(cd "$(dirname "$0")"; pwd -P)
4 __init_tools_log=$__scriptpath/init-tools.log
5 __PACKAGES_DIR=$__scriptpath/packages
6 __TOOLRUNTIME_DIR=$__scriptpath/Tools
7 __DOTNET_PATH=$__TOOLRUNTIME_DIR/dotnetcli
8 __DOTNET_CMD=$__DOTNET_PATH/dotnet
9 if [ -z "$__BUILDTOOLS_SOURCE" ]; then __BUILDTOOLS_SOURCE=https://dotnet.myget.org/F/dotnet-buildtools/api/v3/index.json; fi
10 export __BUILDTOOLS_USE_CSPROJ=true
11 __BUILD_TOOLS_PACKAGE_VERSION=$(cat $__scriptpath/BuildToolsVersion.txt)
12 __DOTNET_TOOLS_VERSION=$(cat $__scriptpath/DotnetCLIVersion.txt)
13 __BUILD_TOOLS_PATH=$__PACKAGES_DIR/microsoft.dotnet.buildtools/$__BUILD_TOOLS_PACKAGE_VERSION/lib
14 __INIT_TOOLS_RESTORE_PROJECT=$__scriptpath/init-tools.msbuild
15 __INIT_TOOLS_DONE_MARKER=$__TOOLRUNTIME_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/done
16
17 if [ -z "$__DOTNET_PKG" ]; then
18     if [ "$(uname -m | grep "i[3456]86")" = "i686" ]; then
19         echo "Error: build not supported on 32 bit Unix"
20         exit 1
21     fi
22 OSName=$(uname -s)
23     case $OSName in
24         Darwin)
25             OS=OSX
26             __DOTNET_PKG=dotnet-dev-osx-x64
27             ulimit -n 2048
28             ;;
29
30         Linux)
31             __DOTNET_PKG=dotnet-dev-linux-x64
32             OS=Linux
33             ;;
34
35         *)
36             echo "Unsupported OS '$OSName' detected. Downloading linux-x64 tools."
37             OS=Linux
38             __DOTNET_PKG=dotnet-dev-linux-x64
39             ;;
40   esac
41 fi
42
43 if [ ! -e $__INIT_TOOLS_DONE_MARKER ]; then
44     __PATCH_CLI_NUGET_FRAMEWORKS=0
45
46     if [ -e $__TOOLRUNTIME_DIR ]; then rm -rf -- $__TOOLRUNTIME_DIR; fi
47     echo "Running: $__scriptpath/init-tools.sh" > $__init_tools_log
48
49     if [ ! -e $__DOTNET_PATH ]; then
50
51         mkdir -p "$__DOTNET_PATH"
52
53         if [ -n "$DOTNET_TOOLSET_DIR" ] && [ -d "$DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION" ]; then
54             echo "Copying $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION to $__DOTNET_PATH" >> $__init_tools_log
55             cp -r $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION/* $__DOTNET_PATH
56         elif [ -n "$DOTNET_TOOL_DIR" ] && [ -d "$DOTNET_TOOL_DIR" ]; then
57             echo "Copying $DOTNET_TOOL_DIR to $__DOTNET_PATH" >> $__init_tools_log
58             cp -r $DOTNET_TOOL_DIR/* $__DOTNET_PATH
59         else
60             echo "Installing dotnet cli..."
61             __DOTNET_LOCATION="https://dotnetcli.blob.core.windows.net/dotnet/Sdk/${__DOTNET_TOOLS_VERSION}/${__DOTNET_PKG}.${__DOTNET_TOOLS_VERSION}.tar.gz"
62             # curl has HTTPS CA trust-issues less often than wget, so lets try that first.
63             echo "Installing '${__DOTNET_LOCATION}' to '$__DOTNET_PATH/dotnet.tar'" >> $__init_tools_log
64             which curl > /dev/null 2> /dev/null
65             if [ $? -ne 0 ]; then
66                 wget -q -O $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
67             else
68                 curl --retry 10 -sSL --create-dirs -o $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
69             fi
70             cd $__DOTNET_PATH
71             tar -xf $__DOTNET_PATH/dotnet.tar
72
73             cd $__scriptpath
74
75             __PATCH_CLI_NUGET_FRAMEWORKS=1
76         fi
77     fi
78
79
80     if [ -n "$BUILD_TOOLS_TOOLSET_DIR" ] && [ -d "$BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION" ]; then
81         echo "Copying $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION to $__TOOLRUNTIME_DIR" >> $__init_tools_log
82         cp -r $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/* $__TOOLRUNTIME_DIR
83     elif [ -n "$BUILD_TOOLS_TOOL_DIR" ] && [ -d "$BUILD_TOOLS_TOOL_DIR" ]; then
84         echo "Copying $BUILD_TOOLS_TOOL_DIR to $__TOOLRUNTIME_DIR" >> $__init_tools_log
85         cp -r $BUILD_TOOLS_TOOL_DIR/* $__TOOLRUNTIME_DIR
86     else
87         if [ ! -e $__BUILD_TOOLS_PATH ]; then
88             echo "Restoring BuildTools version $__BUILD_TOOLS_PACKAGE_VERSION..."
89             echo "Running: $__DOTNET_CMD restore \"$__INIT_TOOLS_RESTORE_PROJECT\" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION" >> $__init_tools_log
90             $__DOTNET_CMD restore "$__INIT_TOOLS_RESTORE_PROJECT" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION >> $__init_tools_log
91             if [ ! -e "$__BUILD_TOOLS_PATH/init-tools.sh" ]; then echo "ERROR: Could not restore build tools correctly. See '$__init_tools_log' for more details."1>&2; fi
92         fi
93
94         echo "Initializing BuildTools..."
95         echo "Running: $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR" >> $__init_tools_log
96
97         # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
98         chmod +x $__BUILD_TOOLS_PATH/init-tools.sh
99         $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR >> $__init_tools_log
100         if [ "$?" != "0" ]; then
101             echo "ERROR: An error occured when trying to initialize the tools. Please check '$__init_tools_log' for more details."1>&2
102             exit 1
103         fi
104     fi
105
106     echo "Making all .sh files executable under Tools."
107     # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
108     ls $__scriptpath/Tools/*.sh | xargs chmod +x
109     ls $__scriptpath/Tools/scripts/docker/*.sh | xargs chmod +x
110
111     Tools/crossgen.sh $__scriptpath/Tools
112
113     touch $__INIT_TOOLS_DONE_MARKER
114
115     echo "Done initializing tools."
116 else
117     echo "Tools are already initialized"
118 fi